;CodeVisionAVR C Compiler V1.24.6 Professional
;(C) Copyright 1998-2005 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;e-mail:office@hpinfotech.com

;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 16,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : float, width, precision
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Automatic register allocation : On

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM


	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM


	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM


	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "ad7416_r.vec"
	.INCLUDE "ad7416_r.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160
;       1 /*****************************************************
;       2 Project : AD7416 I2C
;       3 Version : v1.0
;       4 Date    : 2005.10.09
;       5 Author  : Alfredas
;       6 Company : 
;       7 Comments: AD7416 nuskaitymas per I2C interfeisa.
;       8 Etcherio (spausdintiniu ploksciu esdinimo irenginio) termostatas.
;       9 
;      10 Chip type           : ATmega8
;      11 Program type        : Application
;      12 Clock frequency     : 4,000000 MHz
;      13 Memory model        : Small
;      14 External SRAM size  : 0
;      15 Data Stack size     : 256
;      16 *****************************************************/
;      17 
;      18 #include <mega8.h>
;      19 #include <lcd.h>
;      20 #include <delay.h>
;      21 #include <math.h>
;      22 #include <stdio.h> // sprintf
;      23 
;      24 #define rele1    PORTC.3
;      25 #define LED1     PORTC.2
;      26 
;      27 #define rele2    PORTC.1
;      28 #define LED2     PORTC.0
;      29 
;      30 int LSB,MSB, Data;
;      31 float temp, suma; 
_temp:
	.BYTE 0x4
_suma:
	.BYTE 0x4
;      32 int  kartai, i, termodaviklis;
_termodaviklis:
	.BYTE 0x2
;      33 
;      34 // Alphanumeric LCD Module functions
;      35 #asm
;      36    .equ __lcd_port=0x12 ;PORTD
   .equ __lcd_port=0x12 ;PORTD
;      37 #endasm
;      38 
;      39 // LCD display buffer
;      40 char lcd_buffer[40];
_lcd_buffer:
	.BYTE 0x28
;      41                        
;      42 
;      43 void initialization(){

	.CSEG
_initialization:
;      44 
;      45 PORTB=0x00;
	LDI  R30,LOW(0)
	OUT  0x18,R30
;      46 DDRB=0x00;
	OUT  0x17,R30
;      47 
;      48 PORTC=0x00;
	OUT  0x15,R30
;      49 DDRC=0xFF;
	LDI  R30,LOW(255)
	OUT  0x14,R30
;      50 
;      51 PORTD=0x00;
	LDI  R30,LOW(0)
	OUT  0x12,R30
;      52 DDRD=0x00;
	OUT  0x11,R30
;      53 
;      54 TCCR0=0x00;
	OUT  0x33,R30
;      55 TCNT0=0x00;
	OUT  0x32,R30
;      56 
;      57 // Timer/Counter 1 initialization
;      58 // Clock source: System Clock
;      59 // Clock value: Timer 1 Stopped
;      60 // Mode: Normal top=FFFFh
;      61 // OC1A output: Discon.
;      62 // OC1B output: Discon.
;      63 // Noise Canceler: Off
;      64 // Input Capture on Falling Edge
;      65 // Timer 1 Overflow Interrupt: Off
;      66 // Input Capture Interrupt: Off
;      67 // Compare A Match Interrupt: Off
;      68 // Compare B Match Interrupt: Off
;      69 TCCR1A=0x00;
	OUT  0x2F,R30
;      70 TCCR1B=0x00;
	OUT  0x2E,R30
;      71 TCNT1H=0x00;
	OUT  0x2D,R30
;      72 TCNT1L=0x00;
	OUT  0x2C,R30
;      73 ICR1H=0x00;
	OUT  0x27,R30
;      74 ICR1L=0x00;
	OUT  0x26,R30
;      75 OCR1AH=0x00;
	OUT  0x2B,R30
;      76 OCR1AL=0x00;
	OUT  0x2A,R30
;      77 OCR1BH=0x00;
	OUT  0x29,R30
;      78 OCR1BL=0x00;
	OUT  0x28,R30
;      79 
;      80 // Timer/Counter 2 initialization
;      81 // Clock source: System Clock
;      82 // Clock value: Timer 2 Stopped
;      83 // Mode: Normal top=FFh
;      84 // OC2 output: Disconnected
;      85 ASSR=0x00;
	OUT  0x22,R30
;      86 TCCR2=0x00;
	OUT  0x25,R30
;      87 TCNT2=0x00;
	OUT  0x24,R30
;      88 OCR2=0x00;
	OUT  0x23,R30
;      89 
;      90 // External Interrupt(s) initialization
;      91 // INT0: Off
;      92 // INT1: Off
;      93 MCUCR=0x00;
	OUT  0x35,R30
;      94 
;      95 // Timer(s)/Counter(s) Interrupt(s) initialization
;      96 TIMSK=0x00;
	OUT  0x39,R30
;      97 
;      98 // Analog Comparator initialization
;      99 // Analog Comparator: Off
;     100 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     101 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     102 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     103 
;     104 // 2 Wire Bus initialization
;     105 // Generate Acknowledge Pulse: On
;     106 // 2 Wire Bus Slave Address: 00h
;     107 // General Call Recognition: On
;     108 // Bit Rate: 400,000 kHz
;     109 TWSR=0x00;
	OUT  0x1,R30
;     110 TWCR=0x44;
	LDI  R30,LOW(68)
	OUT  0x36,R30
;     111 TWBR=0x04;
	LDI  R30,LOW(4)
	OUT  0x0,R30
;     112 TWAR=0x00;
	LDI  R30,LOW(0)
	OUT  0x2,R30
;     113 }
	RET
;     114 
;     115 // ----------------------Read data-------------------------------------------------
;     116 float temperatura (int termodaviklis) {
_temperatura:
;     117 
;     118   suma=0; kartai=100;        
	__GETD1N 0x0
	STS  _suma,R30
	STS  _suma+1,R31
	STS  _suma+2,R22
	STS  _suma+3,R23
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	__PUTW1R 10,11
;     119   for(i=1; i<=kartai; i++){
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__PUTW1R 12,13
_0x4:
	__CPWRR 10,11,12,13
	BRGE PC+2
	RJMP _0x5
;     120 
;     121     do {
_0x7:
;     122         TWCR=0b10100100; // I2C START
	LDI  R30,LOW(164)
	OUT  0x36,R30
;     123         while (!(TWCR&0b10000000)); // Waiting ACK
_0x9:
	RCALL SUBOPT_0x0
	BREQ _0x9
;     124     } while ((TWSR&0b11111000)!=0x08); // Siunciamas start kol bus sekmingai ivykdytas
	IN   R30,0x1
	ANDI R30,LOW(0xF8)
	CPI  R30,LOW(0x8)
	BRNE _0x7
;     125 
;     126         TWDR=termodaviklis; // Daviklio adresas su komanda READ
	LD   R30,Y
	LDD  R31,Y+1
	OUT  0x3,R30
;     127         TWCR=0b10000100; // TWINT flag cleared to continue transfer
	RCALL SUBOPT_0x1
;     128         while (!(TWCR&0b10000000)); // Waiting ACK after transmit address and data
_0xC:
	RCALL SUBOPT_0x0
	BREQ _0xC
;     129 
;     130         TWCR=0b10000100; // TWINT flag cleared to continue transfer
	RCALL SUBOPT_0x1
;     131         while (!(TWCR&0b10000000)); 
_0xF:
	RCALL SUBOPT_0x0
	BREQ _0xF
;     132         MSB=TWDR; // Read MSB
	RCALL SUBOPT_0x2
	__PUTW1R 6,7
;     133 
;     134         TWCR=0b10000100;
	RCALL SUBOPT_0x1
;     135         while (!(TWCR&0b10000000));
_0x12:
	RCALL SUBOPT_0x0
	BREQ _0x12
;     136         LSB=TWDR; // Read LSB
	RCALL SUBOPT_0x2
	__PUTW1R 4,5
;     137 
;     138         TWCR=0b10010100; // I2C Stop
	LDI  R30,LOW(148)
	OUT  0x36,R30
;     139        
;     140         LSB=0xC0 & LSB;
	LDI  R30,LOW(192)
	AND  R4,R30
	CLR  R5
;     141         LSB=LSB>>6;
	__GETW2R 4,5
	LDI  R30,LOW(6)
	RCALL __ASRW12
	__PUTW1R 4,5
;     142         temp=(((MSB<<8)+LSB)>>6)*0.25;
	__GETW1R 6,7
	MOV  R31,R30
	LDI  R30,0
	ADD  R30,R4
	ADC  R31,R5
	RCALL __ASRW2
	RCALL __ASRW4
	MOVW R26,R30
	MOVW R24,R22
	RCALL __CWD2
	RCALL __CDF2
	__GETD1N 0x3E800000
	RCALL __MULF12
	RCALL SUBOPT_0x3
;     143         suma=suma+temp;
	LDS  R26,_suma
	LDS  R27,_suma+1
	LDS  R24,_suma+2
	LDS  R25,_suma+3
	RCALL __ADDF12
	STS  _suma,R30
	STS  _suma+1,R31
	STS  _suma+2,R22
	STS  _suma+3,R23
;     144   }            
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	__ADDWRR 12,13,30,31
	RJMP _0x4
_0x5:
;     145         temp=suma/kartai;
	__GETW1R 10,11
	LDS  R26,_suma
	LDS  R27,_suma+1
	LDS  R24,_suma+2
	LDS  R25,_suma+3
	RCALL __CWD1
	RCALL __CDF1
	RCALL __DIVF21
	RCALL SUBOPT_0x3
;     146         return temp;
	ADIW R28,2
	RET
;     147 }
;     148 
;     149 
;     150 
;     151 void main(void) {
_main:
;     152   char sign;
;     153 
;     154         initialization();
;	sign -> R16
	RCALL _initialization
;     155         /* initialize the LCD for 2 lines & 16 columns */
;     156         lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	RCALL _lcd_init
;     157         lcd_clear();
	RCALL _lcd_clear
;     158 
;     159         lcd_gotoxy(2,0);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x5
;     160         sprintf(lcd_buffer, "Etcher v1.0");
	__POINTW1FN _0,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x6
;     161         lcd_puts(lcd_buffer);
;     162         lcd_gotoxy(3,1);
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x7
;     163         sprintf(lcd_buffer, "2005-12-01");
	__POINTW1FN _0,12
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x6
;     164         lcd_puts(lcd_buffer);
;     165         delay_ms(50);
	RCALL SUBOPT_0x8
;     166 
;     167         rele1=1;  
	SBI  0x15,3
;     168         rele2=1;  
	SBI  0x15,1
;     169         sign='+';
	LDI  R16,LOW(43)
;     170 
;     171         lcd_clear();
	RCALL _lcd_clear
;     172 
;     173 while (1){
_0x15:
;     174 
;     175         termodaviklis=0b10010001;
	LDI  R30,LOW(145)
	LDI  R31,HIGH(145)
	RCALL SUBOPT_0x9
;     176         temp = temperatura (termodaviklis);
;     177         
;     178         if (temp<=17) {
	BREQ PC+3
	BRCS PC+2
	RJMP _0x18
;     179           rele1=1;
	SBI  0x15,3
;     180           LED1 =1;
	SBI  0x15,2
;     181           delay_ms(50);
	RCALL SUBOPT_0x8
;     182           LED1 = 0;
	CBI  0x15,2
;     183           delay_ms(50);
	RCALL SUBOPT_0x8
;     184                 }
;     185         if (temp>=20) {
_0x18:
	RCALL SUBOPT_0xA
	BRLO _0x19
;     186           rele1=0;
	CBI  0x15,3
;     187           LED1=0;
	CBI  0x15,2
;     188         }
;     189         if ((temp>17)&&(temp<20))
_0x19:
	RCALL SUBOPT_0xB
	BREQ PC+2
	BRCC PC+2
	RJMP _0x1B
	RCALL SUBOPT_0xA
	BRLO _0x1C
_0x1B:
	RJMP _0x1A
_0x1C:
;     190           LED1=1;
	SBI  0x15,2
;     191         
;     192         lcd_gotoxy(1,0);
_0x1A:
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0x5
;     193         sprintf(lcd_buffer, "E_T = %c%.2f\xDFC",sign, temp);
	__POINTW1FN _0,23
	RCALL SUBOPT_0xD
	LDI  R24,8
	RCALL SUBOPT_0xE
;     194         lcd_puts(lcd_buffer);
;     195                       
;     196         termodaviklis=0b10010011;
	LDI  R30,LOW(147)
	LDI  R31,HIGH(147)
	RCALL SUBOPT_0x9
;     197         temp = temperatura (termodaviklis);
;     198         
;     199         if (temp<=17) {
	BREQ PC+3
	BRCS PC+2
	RJMP _0x1D
;     200           rele2=1;
	SBI  0x15,1
;     201           LED2 =1;
	SBI  0x15,0
;     202           delay_ms(50);
	RCALL SUBOPT_0x8
;     203           LED2 = 0;
	CBI  0x15,0
;     204           delay_ms(50);
	RCALL SUBOPT_0x8
;     205                 }
;     206         if (temp>=20) {
_0x1D:
	RCALL SUBOPT_0xA
	BRLO _0x1E
;     207           rele2=0;
	CBI  0x15,1
;     208           LED2=0;
	CBI  0x15,0
;     209         }
;     210         if ((temp>17)&&(temp<20))
_0x1E:
	RCALL SUBOPT_0xB
	BREQ PC+2
	BRCC PC+2
	RJMP _0x20
	RCALL SUBOPT_0xA
	BRLO _0x21
_0x20:
	RJMP _0x1F
_0x21:
;     211           LED2=1;
	SBI  0x15,0
;     212 
;     213         lcd_gotoxy(1,1);
_0x1F:
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x7
;     214         sprintf(lcd_buffer, "V_T = %c%.2f\xDFC",sign, temp);
	__POINTW1FN _0,38
	RCALL SUBOPT_0xD
	LDI  R24,8
	RCALL SUBOPT_0xE
;     215         lcd_puts(lcd_buffer); 
;     216 	
;     217 }
	RJMP _0x15
;     218 }
_0x22:
	RJMP _0x22

    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG
__base_y_G2:
	.BYTE 0x4
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1

	.CSEG
__lcd_delay_G2:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
	RET
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
	RCALL __lcd_delay_G2
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G2
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G2
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G2
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble_G2:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G2
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G2
	RET
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf0 | (1<<__lcd_rs) | (1<<__lcd_rd) | (1<<__lcd_enable) ;set as output    
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	RCALL __lcd_write_nibble_G2
    ld    r26,y
    swap  r26
	RCALL __lcd_write_nibble_G2
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
__lcd_read_nibble_G2:
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G2
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G2
    andi  r30,0xf0
	RET
_lcd_read_byte0_G2:
	RCALL __lcd_delay_G2
	RCALL __lcd_read_nibble_G2
    mov   r26,r30
	RCALL __lcd_read_nibble_G2
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	RCALL __lcd_ready
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G2)
	SBCI R31,HIGH(-__base_y_G2)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	RCALL SUBOPT_0xF
	LDD  R14,Y+1
	LD   R30,Y
	STS  __lcd_y,R30
	ADIW R28,2
	RET
_lcd_clear:
	RCALL __lcd_ready
	RCALL SUBOPT_0x4
	RCALL __lcd_write_data
	RCALL __lcd_ready
	LDI  R30,LOW(12)
	RCALL SUBOPT_0xF
	RCALL __lcd_ready
	RCALL SUBOPT_0xC
	RCALL __lcd_write_data
	LDI  R30,LOW(0)
	STS  __lcd_y,R30
	MOV  R14,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	INC  R14
	LDS  R30,__lcd_maxx
	CP   R30,R14
	BRSH _0x24
	__lcd_putchar1:
	LDS  R30,__lcd_y
	SUBI R30,-LOW(1)
	STS  __lcd_y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDS  R30,__lcd_y
	ST   -Y,R30
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0x24:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	ADIW R28,1
	RET
_lcd_puts:
    ldd  r31,y+1
    ld   r30,y
__lcd_puts0:
    ld   r26,z+
    tst  r26
    breq __lcd_puts1
    st   -y,r26    
    rcall _lcd_putchar
    rjmp __lcd_puts0
__lcd_puts1:
	ADIW R28,2
	RET
__long_delay_G2:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G2:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	RCALL __lcd_write_nibble_G2
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G2,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G2,3
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0x10
	RCALL __long_delay_G2
	RCALL SUBOPT_0x11
	RCALL __lcd_init_write_G2
	RCALL __long_delay_G2
	LDI  R30,LOW(40)
	RCALL SUBOPT_0xF
	RCALL __long_delay_G2
	LDI  R30,LOW(4)
	RCALL SUBOPT_0xF
	RCALL __long_delay_G2
	LDI  R30,LOW(133)
	RCALL SUBOPT_0xF
	RCALL __long_delay_G2
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RCALL _lcd_read_byte0_G2
	CPI  R30,LOW(0x5)
	BREQ _0x25
	LDI  R30,LOW(0)
	RJMP _0xD0
_0x25:
	RCALL __lcd_ready
	LDI  R30,LOW(6)
	RCALL SUBOPT_0xF
	RCALL _lcd_clear
	LDI  R30,LOW(1)
_0xD0:
	ADIW R28,1
	RET
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G4:
	put:
	RCALL SUBOPT_0x12
	SBIW R30,0
	BREQ _0x26
	RCALL SUBOPT_0x12
	ADIW R30,1
	ST   X+,R30
	ST   X,R31
	SBIW R30,1
	LDD  R26,Y+2
	STD  Z+0,R26
	RJMP _0x27
_0x26:
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _putchar
_0x27:
	ADIW R28,3
	RET
__ftoa_G4:
	SBIW R28,4
	RCALL __SAVELOCR2
	LDD  R26,Y+8
	RCALL SUBOPT_0x13
	BRSH _0x28
	LDI  R30,LOW(5)
	STD  Y+8,R30
_0x28:
	LDI  R26,LOW(__fround_G4*2)
	LDI  R27,HIGH(__fround_G4*2)
	LDD  R30,Y+8
	LDI  R31,0
	RCALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	RCALL __GETD1PF
	__GETD2S 9
	RCALL __ADDF12
	__PUTD1S 9
	LDI  R16,LOW(0)
	__GETD1N 0x3F800000
	__PUTD1S 2
_0x29:
	RCALL SUBOPT_0x14
	RCALL __CMPF12
	BRLO _0x2B
	RCALL SUBOPT_0x15
	RCALL __MULF12
	__PUTD1S 2
	SUBI R16,-LOW(1)
	RJMP _0x29
_0x2B:
	CPI  R16,0
	BRNE _0x2C
	RCALL SUBOPT_0x16
	LDI  R30,LOW(48)
	ST   X,R30
	RJMP _0x2D
_0x2C:
_0x2E:
	MOV  R30,R16
	SUBI R16,1
	CPI  R30,0
	BREQ _0x30
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x17
	__PUTD1S 2
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x19
	__GETD2S 2
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __CDF1
	RCALL __MULF12
	__GETD2S 9
	RCALL SUBOPT_0x1A
	RJMP _0x2E
_0x30:
_0x2D:
	LDD  R30,Y+8
	CPI  R30,0
	BRNE _0x31
	RCALL SUBOPT_0x1B
	RJMP _0xCF
_0x31:
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x1C
_0x32:
	LDD  R30,Y+8
	SUBI R30,LOW(1)
	STD  Y+8,R30
	SUBI R30,-LOW(1)
	BREQ _0x34
	__GETD2S 9
	RCALL SUBOPT_0x1D
	__PUTD1S 9
	RCALL __CFD1
	MOV  R17,R30
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x19
	__GETD2S 9
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __CDF1
	RCALL SUBOPT_0x1A
	RJMP _0x32
_0x34:
	RCALL SUBOPT_0x1B
_0xCF:
	RCALL __LOADLOCR2
	ADIW R28,13
	RET
__ftoe_G4:
	SBIW R28,4
	RCALL __SAVELOCR3
	__GETD1N 0x3F800000
	__PUTD1S 3
	LDD  R26,Y+10
	RCALL SUBOPT_0x13
	BRSH _0x35
	LDI  R30,LOW(5)
	STD  Y+10,R30
_0x35:
	LDD  R16,Y+10
_0x36:
	MOV  R30,R16
	SUBI R16,1
	CPI  R30,0
	BREQ _0x38
	RCALL SUBOPT_0x1E
	__PUTD1S 3
	RJMP _0x36
_0x38:
	__GETD1S 11
	RCALL __CPD10
	BRNE _0x39
	LDI  R18,LOW(0)
	RCALL SUBOPT_0x1E
	__PUTD1S 3
	RJMP _0x3A
_0x39:
	LDD  R18,Y+10
	RCALL SUBOPT_0x1F
	BREQ PC+2
	BRCC PC+2
	RJMP _0x3B
	RCALL SUBOPT_0x1E
	__PUTD1S 3
_0x3C:
	RCALL SUBOPT_0x1F
	BRLO _0x3E
	RCALL SUBOPT_0x20
	SUBI R18,-LOW(1)
	RJMP _0x3C
_0x3E:
	RJMP _0x3F
_0x3B:
_0x40:
	RCALL SUBOPT_0x1F
	BRSH _0x42
	__GETD2S 11
	RCALL SUBOPT_0x1D
	__PUTD1S 11
	SUBI R18,LOW(1)
	RJMP _0x40
_0x42:
	RCALL SUBOPT_0x1E
	__PUTD1S 3
_0x3F:
	__GETD1S 11
	__GETD2N 0x3F000000
	RCALL __ADDF12
	__PUTD1S 11
	RCALL SUBOPT_0x1F
	BRLO _0x43
	RCALL SUBOPT_0x20
	SUBI R18,-LOW(1)
_0x43:
_0x3A:
	LDI  R16,LOW(0)
_0x44:
	LDD  R30,Y+10
	CP   R30,R16
	BRLO _0x46
	__GETD2S 3
	__GETD1N 0x41200000
	RCALL SUBOPT_0x17
	__PUTD1S 3
	__GETD2S 11
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x19
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __CDF1
	__GETD2S 3
	RCALL __MULF12
	__GETD2S 11
	RCALL __SWAPD12
	RCALL __SUBF12
	__PUTD1S 11
	MOV  R30,R16
	SUBI R16,-1
	CPI  R30,0
	BRNE _0x44
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x1C
	RJMP _0x44
_0x46:
	RCALL SUBOPT_0x22
	LDD  R26,Y+9
	STD  Z+0,R26
	CPI  R18,0
	BRGE _0x48
	RCALL SUBOPT_0x21
	LDI  R30,LOW(45)
	ST   X,R30
	NEG  R18
_0x48:
	LDI  R30,LOW(9)
	CP   R30,R18
	BRGE _0x49
	RCALL SUBOPT_0x22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x23
	RCALL __DIVB21
	SUBI R30,-LOW(48)
	POP  R26
	POP  R27
	ST   X,R30
_0x49:
	RCALL SUBOPT_0x22
	PUSH R31
	PUSH R30
	RCALL SUBOPT_0x23
	RCALL __MODB21
	SUBI R30,-LOW(48)
	POP  R26
	POP  R27
	ST   X,R30
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	RCALL SUBOPT_0x24
	RCALL __LOADLOCR3
	ADIW R28,15
	RET
__print_sign_G4:
    ;flags&=~F_SIGNED
    andi r17,~4
    ;_put(s,ptr_ps)
    ldd  r30,y+17
    st   -y,r30
    ldd  r30,y+19+16
    ldd  r31,y+20+16
    st   -y,r31
    st   -y,r30
    rcall put
    ;if (width) --width
    cpi  r20,0
    breq width0
    dec  r20
width0:
	RET
__print_G4:
	SBIW R28,28
	RCALL __SAVELOCR6
	LDI  R16,0
_0x4A:
	LDD  R30,Y+38
	LDD  R31,Y+38+1
	ADIW R30,1
	STD  Y+38,R30
	STD  Y+38+1,R31
	RCALL SUBOPT_0x25
	MOV  R19,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x4C
	MOV  R30,R16
	CPI  R30,0
	BRNE _0x50
	CPI  R19,37
	BRNE _0x51
	LDI  R16,LOW(1)
	RJMP _0x52
_0x51:
	RCALL SUBOPT_0x26
_0x52:
	RJMP _0x4F
_0x50:
	CPI  R30,LOW(0x1)
	BRNE _0x53
	CPI  R19,37
	BRNE _0x54
	RCALL SUBOPT_0x26
	LDI  R16,LOW(0)
	RJMP _0x4F
_0x54:
	LDI  R16,LOW(2)
	LDI  R30,LOW(0)
	STD  Y+17,R30
	LDI  R17,LOW(0)
	CPI  R19,45
	BRNE _0x55
	LDI  R17,LOW(1)
	RJMP _0x4F
_0x55:
	CPI  R19,43
	BRNE _0x56
	LDI  R30,LOW(43)
	STD  Y+17,R30
	RJMP _0x4F
_0x56:
	CPI  R19,32
	BRNE _0x57
	LDI  R30,LOW(32)
	STD  Y+17,R30
	RJMP _0x4F
_0x57:
	RJMP _0x58
_0x53:
	CPI  R30,LOW(0x2)
	BRNE _0x59
_0x58:
	LDI  R20,LOW(0)
	LDI  R16,LOW(3)
	CPI  R19,48
	BRNE _0x5A
	ORI  R17,LOW(128)
	RJMP _0x4F
_0x5A:
	RJMP _0x5B
_0x59:
	CPI  R30,LOW(0x3)
	BRNE _0x5C
_0x5B:
	CPI  R19,48
	BRLO _0x5E
	CPI  R19,58
	BRLO _0x5F
_0x5E:
	RJMP _0x5D
_0x5F:
	MOV  R26,R20
	RCALL SUBOPT_0x27
	MOV  R20,R30
	RCALL SUBOPT_0x28
	ADD  R20,R30
	RJMP _0x4F
_0x5D:
	LDI  R21,LOW(0)
	CPI  R19,46
	BRNE _0x60
	LDI  R16,LOW(4)
	RJMP _0x4F
_0x60:
	RJMP _0x61
_0x5C:
	CPI  R30,LOW(0x4)
	BRNE _0x63
	CPI  R19,48
	BRLO _0x65
	CPI  R19,58
	BRLO _0x66
_0x65:
	RJMP _0x64
_0x66:
	ORI  R17,LOW(32)
	MOV  R26,R21
	RCALL SUBOPT_0x27
	MOV  R21,R30
	RCALL SUBOPT_0x28
	ADD  R21,R30
	RJMP _0x4F
_0x64:
_0x61:
	CPI  R19,108
	BRNE _0x67
	ORI  R17,LOW(2)
	LDI  R16,LOW(5)
	RJMP _0x4F
_0x67:
	RJMP _0x68
_0x63:
	CPI  R30,LOW(0x5)
	BREQ PC+2
	RJMP _0x4F
_0x68:
	MOV  R30,R19
	CPI  R30,LOW(0x63)
	BRNE _0x6D
	RCALL SUBOPT_0x29
	LD   R30,X
	RCALL SUBOPT_0x2A
	RJMP _0x6E
_0x6D:
	CPI  R30,LOW(0x45)
	BREQ _0x71
	CPI  R30,LOW(0x65)
	BRNE _0x72
_0x71:
	RJMP _0x73
_0x72:
	CPI  R30,LOW(0x66)
	BRNE _0x74
_0x73:
	RCALL SUBOPT_0x2B
	RCALL SUBOPT_0x29
	RCALL __GETD1P
	__PUTD1S 8
	MOVW R26,R30
	MOVW R24,R22
	RCALL __CPD20
	BRLT _0x75
	LDD  R26,Y+17
	CPI  R26,LOW(0x2B)
	BREQ _0x77
	RJMP _0x78
_0x75:
	__GETD1S 8
	RCALL __ANEGF1
	RCALL SUBOPT_0x2C
_0x77:
	SBRS R17,7
	RJMP _0x79
	LDD  R30,Y+17
	RCALL SUBOPT_0x2A
	RJMP _0x7A
_0x79:
	RCALL SUBOPT_0x2D
	SBIW R30,1
	LDD  R26,Y+17
	STD  Z+0,R26
_0x7A:
_0x78:
	SBRS R17,5
	LDI  R21,LOW(5)
	CPI  R19,102
	BRNE _0x7C
	RCALL SUBOPT_0x2E
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL __ftoa_G4
	RJMP _0x7D
_0x7C:
	RCALL SUBOPT_0x2E
	ST   -Y,R19
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL __ftoe_G4
_0x7D:
	RCALL SUBOPT_0x2B
	RCALL SUBOPT_0x2F
	RJMP _0x7E
_0x74:
	CPI  R30,LOW(0x73)
	BRNE _0x80
	RCALL SUBOPT_0x29
	RCALL SUBOPT_0x30
	RCALL SUBOPT_0x2F
	RJMP _0x81
_0x80:
	CPI  R30,LOW(0x70)
	BRNE _0x83
	RCALL SUBOPT_0x29
	RCALL SUBOPT_0x30
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _strlenf
	MOV  R16,R30
	ORI  R17,LOW(8)
_0x81:
	ANDI R17,LOW(127)
	CPI  R21,0
	BREQ _0x85
	CP   R21,R16
	BRLO _0x86
_0x85:
	RJMP _0x84
_0x86:
	MOV  R16,R21
_0x84:
_0x7E:
	LDI  R21,LOW(0)
	LDI  R30,LOW(0)
	STD  Y+16,R30
	LDI  R18,LOW(0)
	RJMP _0x87
_0x83:
	CPI  R30,LOW(0x64)
	BREQ _0x8A
	CPI  R30,LOW(0x69)
	BRNE _0x8B
_0x8A:
	ORI  R17,LOW(4)
	RJMP _0x8C
_0x8B:
	CPI  R30,LOW(0x75)
	BRNE _0x8D
_0x8C:
	LDI  R30,LOW(10)
	STD  Y+16,R30
	SBRS R17,1
	RJMP _0x8E
	__GETD1N 0x3B9ACA00
	__PUTD1S 12
	LDI  R16,LOW(10)
	RJMP _0x8F
_0x8E:
	__GETD1N 0x2710
	__PUTD1S 12
	LDI  R16,LOW(5)
	RJMP _0x8F
_0x8D:
	CPI  R30,LOW(0x58)
	BRNE _0x91
	ORI  R17,LOW(8)
	RJMP _0x92
_0x91:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0xCE
_0x92:
	LDI  R30,LOW(16)
	STD  Y+16,R30
	SBRS R17,1
	RJMP _0x94
	__GETD1N 0x10000000
	__PUTD1S 12
	LDI  R16,LOW(8)
	RJMP _0x8F
_0x94:
	__GETD1N 0x1000
	__PUTD1S 12
	LDI  R16,LOW(4)
_0x8F:
	CPI  R21,0
	BREQ _0x95
	ANDI R17,LOW(127)
	RJMP _0x96
_0x95:
	LDI  R21,LOW(1)
_0x96:
	SBRS R17,1
	RJMP _0x97
	RCALL SUBOPT_0x29
	RCALL __GETD1P
	RJMP _0xD1
_0x97:
	SBRS R17,2
	RJMP _0x99
	RCALL SUBOPT_0x29
	RCALL __GETW1P
	RCALL __CWD1
	RJMP _0xD1
_0x99:
	RCALL SUBOPT_0x29
	RCALL __GETW1P
	CLR  R22
	CLR  R23
_0xD1:
	__PUTD1S 8
	SBRS R17,2
	RJMP _0x9B
	__GETD2S 8
	RCALL __CPD20
	BRGE _0x9C
	__GETD1S 8
	RCALL __ANEGD1
	RCALL SUBOPT_0x2C
_0x9C:
	LDD  R30,Y+17
	CPI  R30,0
	BREQ _0x9D
	SUBI R16,-LOW(1)
	SUBI R21,-LOW(1)
	RJMP _0x9E
_0x9D:
	ANDI R17,LOW(251)
_0x9E:
_0x9B:
	MOV  R18,R21
_0x87:
	SBRC R17,0
	RJMP _0x9F
_0xA0:
	CP   R16,R20
	BRSH _0xA3
	CP   R18,R20
	BRLO _0xA4
_0xA3:
	RJMP _0xA2
_0xA4:
	SBRS R17,7
	RJMP _0xA5
	SBRS R17,2
	RJMP _0xA6
	ANDI R17,LOW(251)
	LDD  R19,Y+17
	SUBI R16,LOW(1)
	RJMP _0xA7
_0xA6:
	LDI  R19,LOW(48)
_0xA7:
	RJMP _0xA8
_0xA5:
	LDI  R19,LOW(32)
_0xA8:
	RCALL SUBOPT_0x26
	SUBI R20,LOW(1)
	RJMP _0xA0
_0xA2:
_0x9F:
_0xA9:
	CP   R16,R21
	BRSH _0xAB
	ORI  R17,LOW(16)
	SBRS R17,2
	RJMP _0xAC
	RCALL __print_sign_G4
	SUBI R16,LOW(1)
	SUBI R21,LOW(1)
_0xAC:
	LDI  R30,LOW(48)
	RCALL SUBOPT_0x2A
	CPI  R20,0
	BREQ _0xAD
	SUBI R20,LOW(1)
_0xAD:
	SUBI R21,LOW(1)
	RJMP _0xA9
_0xAB:
	MOV  R18,R16
	LDD  R30,Y+16
	CPI  R30,0
	BRNE _0xAE
_0xAF:
	CPI  R18,0
	BREQ _0xB1
	SBRS R17,3
	RJMP _0xB2
	RCALL SUBOPT_0x2D
	RCALL SUBOPT_0x25
	RJMP _0xD2
_0xB2:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0xD2:
	ST   -Y,R30
	RCALL SUBOPT_0x31
	CPI  R20,0
	BREQ _0xB4
	SUBI R20,LOW(1)
_0xB4:
	SUBI R18,LOW(1)
	RJMP _0xAF
_0xB1:
	RJMP _0xB5
_0xAE:
_0xB7:
	RCALL SUBOPT_0x32
	RCALL __DIVD21U
	MOV  R19,R30
	LDI  R30,LOW(9)
	CP   R30,R19
	BRSH _0xB9
	SBRS R17,3
	RJMP _0xBA
	SUBI R19,-LOW(55)
	RJMP _0xBB
_0xBA:
	SUBI R19,-LOW(87)
_0xBB:
	RJMP _0xBC
_0xB9:
	SUBI R19,-LOW(48)
_0xBC:
	SBRC R17,4
	RJMP _0xBE
	LDI  R30,LOW(48)
	CP   R30,R19
	BRLO _0xC0
	__GETD2S 12
	__CPD2N 0x1
	BRNE _0xBF
_0xC0:
	RJMP _0xC2
_0xBF:
	CP   R21,R18
	BRLO _0xC3
	LDI  R19,LOW(48)
	RJMP _0xC2
_0xC3:
	CP   R20,R18
	BRLO _0xC5
	SBRS R17,0
	RJMP _0xC6
_0xC5:
	RJMP _0xC4
_0xC6:
	LDI  R19,LOW(32)
	SBRS R17,7
	RJMP _0xC7
	LDI  R19,LOW(48)
_0xC2:
	ORI  R17,LOW(16)
	SBRC R17,2
	RCALL __print_sign_G4
_0xC7:
_0xBE:
	RCALL SUBOPT_0x26
	CPI  R20,0
	BREQ _0xC9
	SUBI R20,LOW(1)
_0xC9:
_0xC4:
	SUBI R18,LOW(1)
	RCALL SUBOPT_0x32
	RCALL __MODD21U
	__PUTD1S 8
	LDD  R30,Y+16
	__GETD2S 12
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __DIVD21U
	__PUTD1S 12
	RCALL __CPD10
	BREQ _0xB8
	RJMP _0xB7
_0xB8:
_0xB5:
	SBRS R17,0
	RJMP _0xCA
_0xCB:
	CPI  R20,0
	BREQ _0xCD
	SUBI R20,LOW(1)
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x31
	RJMP _0xCB
_0xCD:
_0xCA:
_0xCE:
_0x6E:
	LDI  R16,LOW(0)
_0x4F:
	RJMP _0x4A
_0x4C:
	RCALL __LOADLOCR6
	ADIW R28,40
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,2
	RCALL __SAVELOCR2
	MOVW R26,R28
	RCALL __ADDW2R15
	__PUTW2R 16,17
	MOVW R26,R28
	ADIW R26,6
	RCALL SUBOPT_0x33
	STD  Y+2,R30
	STD  Y+2+1,R31
	MOVW R26,R28
	ADIW R26,4
	RCALL SUBOPT_0x33
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G4
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RCALL SUBOPT_0x24
	RCALL __LOADLOCR2
	ADIW R28,4
	POP  R15
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x0:
	IN   R30,0x36
	ANDI R30,LOW(0x80)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1:
	LDI  R30,LOW(132)
	OUT  0x36,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2:
	IN   R30,0x3
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	STS  _temp,R30
	STS  _temp+1,R31
	STS  _temp+2,R22
	STS  _temp+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4:
	LDI  R30,LOW(2)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x5:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _lcd_gotoxy
	LDI  R30,LOW(_lcd_buffer)
	LDI  R31,HIGH(_lcd_buffer)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	RCALL _sprintf
	ADIW R28,4
	LDI  R30,LOW(_lcd_buffer)
	LDI  R31,HIGH(_lcd_buffer)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x7:
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _lcd_gotoxy
	LDI  R30,LOW(_lcd_buffer)
	LDI  R31,HIGH(_lcd_buffer)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x8:
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9:
	STS  _termodaviklis,R30
	STS  _termodaviklis+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RCALL _temperatura
	STS  _temp,R30
	STS  _temp+1,R31
	STS  _temp+2,R22
	STS  _temp+3,R23
	LDS  R26,_temp
	LDS  R27,_temp+1
	LDS  R24,_temp+2
	LDS  R25,_temp+3
	__GETD1N 0x41880000
	RCALL __CMPF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0xA:
	LDS  R26,_temp
	LDS  R27,_temp+1
	LDS  R24,_temp+2
	LDS  R25,_temp+3
	__GETD1N 0x41A00000
	RCALL __CMPF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xB:
	LDS  R26,_temp
	LDS  R27,_temp+1
	LDS  R24,_temp+2
	LDS  R25,_temp+3
	__GETD1N 0x41880000
	RCALL __CMPF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xC:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xD:
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R16
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDS  R30,_temp
	LDS  R31,_temp+1
	LDS  R22,_temp+2
	LDS  R23,_temp+3
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xE:
	RCALL _sprintf
	ADIW R28,12
	LDI  R30,LOW(_lcd_buffer)
	LDI  R31,HIGH(_lcd_buffer)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0xF:
	ST   -Y,R30
	RJMP __lcd_write_data

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x10:
	RCALL __long_delay_G2
	LDI  R30,LOW(48)
	ST   -Y,R30
	RJMP __lcd_init_write_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x11:
	LDI  R30,LOW(32)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x12:
	LD   R26,Y
	LDD  R27,Y+1
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x13:
	LDI  R30,LOW(5)
	CP   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x14:
	__GETD1S 2
	__GETD2S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x15:
	__GETD2S 2
	__GETD1N 0x41200000
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x16:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x17:
	RCALL __DIVF21
	__GETD2N 0x3F000000
	RCALL __ADDF12
	RCALL __PUTPARD1
	RJMP _floor

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x18:
	RCALL __DIVF21
	RCALL __CFD1
	MOV  R17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x19:
	MOV  R30,R17
	SUBI R30,-LOW(48)
	ST   X,R30
	MOV  R30,R17
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1A:
	RCALL __SWAPD12
	RCALL __SUBF12
	__PUTD1S 9
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1B:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1C:
	LDI  R30,LOW(46)
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x1D:
	__GETD1N 0x41200000
	RCALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x1E:
	__GETD2S 3
	RJMP SUBOPT_0x1D

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x1F:
	__GETD1S 3
	__GETD2S 11
	RCALL __CMPF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x20:
	__GETD2S 11
	__GETD1N 0x41200000
	RCALL __DIVF21
	__PUTD1S 11
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x21:
	LDD  R26,Y+7
	LDD  R27,Y+7+1
	ADIW R26,1
	STD  Y+7,R26
	STD  Y+7+1,R27
	SBIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x22:
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	ADIW R30,1
	STD  Y+7,R30
	STD  Y+7+1,R31
	SBIW R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x23:
	MOV  R26,R18
	LDI  R30,LOW(10)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x24:
	LDI  R30,LOW(0)
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x25:
	SBIW R30,1
	LPM  R30,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x26:
	ST   -Y,R19
	LDD  R30,Y+35
	LDD  R31,Y+35+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G4

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x27:
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOV  R30,R0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x28:
	MOV  R30,R19
	SUBI R30,LOW(48)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x29:
	LDD  R26,Y+36
	LDD  R27,Y+36+1
	SBIW R26,4
	STD  Y+36,R26
	STD  Y+36+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x2A:
	ST   -Y,R30
	LDD  R30,Y+35
	LDD  R31,Y+35+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G4

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2B:
	MOVW R30,R28
	ADIW R30,18
	STD  Y+6,R30
	STD  Y+6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2C:
	__PUTD1S 8
	LDI  R30,LOW(45)
	STD  Y+17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2D:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2E:
	__GETD1S 8
	RCALL __PUTPARD1
	ST   -Y,R21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2F:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _strlen
	MOV  R16,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x30:
	RCALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x31:
	LDD  R30,Y+35
	LDD  R31,Y+35+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G4

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x32:
	__GETD1S 12
	__GETD2S 8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x33:
	RCALL __ADDW2R15
	RCALL __GETW1P
	RET

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ftrunc:
	ldd  r23,y+3
	ldd  r22,y+2
	ldd  r31,y+1
	ld   r30,y
	bst  r23,7
	lsl  r23
	sbrc r22,7
	sbr  r23,1
	mov  r25,r23
	subi r25,0x7e
	breq __ftrunc0
	brcs __ftrunc0
	cpi  r25,24
	brsh __ftrunc1
	clr  r26
	clr  r27
	clr  r24
__ftrunc2:
	sec
	ror  r24
	ror  r27
	ror  r26
	dec  r25
	brne __ftrunc2
	and  r30,r26
	and  r31,r27
	and  r22,r24
	rjmp __ftrunc1
__ftrunc0:
	clt
	clr  r23
	clr  r30
	clr  r31
	clr  r22
__ftrunc1:
	cbr  r22,0x80
	lsr  r23
	brcc __ftrunc3
	sbr  r22,0x80
__ftrunc3:
	bld  r23,7
	ld   r26,y+
	ld   r27,y+
	ld   r24,y+
	ld   r25,y+
	cp   r30,r26
	cpc  r31,r27
	cpc  r22,r24
	cpc  r23,r25
	bst  r25,7
	ret

_floor:
	rcall __ftrunc
	brne __floor1
__floor0:
	ret
__floor1:
	brtc __floor0
	ldi  r25,0xbf

__addfc:
	clr  r26
	clr  r27
	ldi  r24,0x80
	rjmp __addf12

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGD1:
	COM  R30
	COM  R31
	COM  R22
	COM  R23
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__ASRW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __ASRW12R
__ASRW12L:
	ASR  R31
	ROR  R30
	DEC  R0
	BRNE __ASRW12L
__ASRW12R:
	RET

__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__ASRW4:
	ASR  R31
	ROR  R30
__ASRW3:
	ASR  R31
	ROR  R30
__ASRW2:
	ASR  R31
	ROR  R30
	ASR  R31
	ROR  R30
	RET

__CBD1:
	MOV  R31,R30
	ADD  R31,R31
	SBC  R31,R31
	MOV  R22,R31
	MOV  R23,R31
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__CWD2:
	MOV  R24,R27
	ADD  R24,R24
	SBC  R24,R24
	MOV  R25,R24
	RET

__DIVB21U:
	CLR  R0
	LDI  R25,8
__DIVB21U1:
	LSL  R26
	ROL  R0
	SUB  R0,R30
	BRCC __DIVB21U2
	ADD  R0,R30
	RJMP __DIVB21U3
__DIVB21U2:
	SBR  R26,1
__DIVB21U3:
	DEC  R25
	BRNE __DIVB21U1
	MOV  R30,R26
	MOV  R26,R0
	RET

__DIVB21:
	RCALL __CHKSIGNB
	RCALL __DIVB21U
	BRTC __DIVB211
	NEG  R30
__DIVB211:
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R19
	CLR  R20
	LDI  R21,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R19
	ROL  R20
	SUB  R0,R30
	SBC  R1,R31
	SBC  R19,R22
	SBC  R20,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R19,R22
	ADC  R20,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R21
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOV  R24,R19
	MOV  R25,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__MODB21:
	CLT
	SBRS R26,7
	RJMP __MODB211
	NEG  R26
	SET
__MODB211:
	SBRC R30,7
	NEG  R30
	RCALL __DIVB21U
	MOV  R30,R26
	BRTC __MODB212
	NEG  R30
__MODB212:
	RET

__MODD21U:
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	RET

__CHKSIGNB:
	CLT
	SBRS R30,7
	RJMP __CHKSB1
	NEG  R30
	SET
__CHKSB1:
	SBRS R26,7
	RJMP __CHKSB2
	NEG  R26
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSB2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__GETD1PF:
	LPM  R0,Z+
	LPM  R1,Z+
	LPM  R22,Z+
	LPM  R23,Z
	MOVW R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__CDF2U:
	SET
	RJMP __CDF2U0
__CDF2:
	CLT
__CDF2U0:
	RCALL __SWAPD12
	RCALL __CDF1U0

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__ANEGF1:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __ANEGF10
	SUBI R23,0x80
__ANEGF10:
	RET

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	MOV  R21,R30
	MOV  R30,R26
	MOV  R26,R21
	MOV  R21,R31
	MOV  R31,R27
	MOV  R27,R21
	MOV  R21,R22
	MOV  R22,R24
	MOV  R24,R21
	MOV  R21,R23
	MOV  R23,R25
	MOV  R25,R21
	MOV  R21,R0
	MOV  R0,R1
	MOV  R1,R21
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

	RJMP __ADDF120

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF129
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,24
__MULF120:
	LSL  R19
	ROL  R20
	ROL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	BRCC __MULF121
	ADD  R19,R26
	ADC  R20,R27
	ADC  R21,R24
	ADC  R30,R1
	ADC  R31,R1
	ADC  R22,R1
__MULF121:
	DEC  R25
	BRNE __MULF120
	POP  R20
	POP  R19
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __REPACK
	POP  R21
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __MAXRES
	RJMP __MINRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	LSR  R22
	ROR  R31
	ROR  R30
	LSR  R24
	ROR  R27
	ROR  R26
	PUSH R20
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R25,24
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R1
	ROL  R20
	ROL  R21
	ROL  R26
	ROL  R27
	ROL  R24
	DEC  R25
	BRNE __DIVF212
	MOV  R30,R1
	MOV  R31,R20
	MOV  R22,R21
	LSR  R26
	ADC  R30,R25
	ADC  R31,R25
	ADC  R22,R25
	POP  R20
	TST  R22
	BRMI __DIVF215
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __REPACK
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__CPD20:
	SBIW R26,0
	SBCI R24,0
	SBCI R25,0
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
